#include <iostream>

#include "cliffc_hashtable.h"

using namespace std;

template<typename TypeK, typename TypeV>
slot* const cliffc_hashtable<TypeK, TypeV>::MATCH_ANY = new slot(false, NULL);

template<typename TypeK, typename TypeV>
slot* const cliffc_hashtable<TypeK, TypeV>::NO_MATCH_OLD = new slot(false, NULL);

template<typename TypeK, typename TypeV>
slot* const cliffc_hashtable<TypeK, TypeV>::TOMBPRIME = new slot(true, NULL);

template<typename TypeK, typename TypeV>
slot* const cliffc_hashtable<TypeK, TypeV>::TOMBSTONE = new slot(false, NULL);


class IntWrapper {
	private:
	    int _val;
		public:

		IntWrapper(int val) : _val(val) {}

		IntWrapper() : _val(0) {}

		IntWrapper(IntWrapper& copy) : _val(copy._val) {}

		int get() {
			return _val;
		}

		int hashCode() {
			return _val;
		}

		bool equals(const shared_ptr<void> another) {
			if (another == NULL)
				return false;
			shared_ptr<IntWrapper> ptr =
				static_pointer_cast<IntWrapper>(another);
			return ptr->_val == _val;
		}
};

int main(int argc, char *argv[]) {
	cliffc_hashtable<IntWrapper, IntWrapper> table;
	IntWrapper k1(3), k2(4), v1(1), v2(2);
	

	table.put(k1, v1);
	table.put(k2, v2);
	cout << table.get(k2)->get() << endl;
	return 1;
}
